## radiotray-ng 0.2.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(radiotray-ng CXX)

# workaround for Eclipse
if (${CMAKE_EXTRA_GENERATOR} MATCHES "Eclipse CDT4")
	set(CMAKE_CXX_COMPILER_ARG1 "-std=c++14"
		CACHE STRING "C++ version for Eclipse's indexer" FORCE)
	set(CMAKE_ECLIPSE_VERSION "4.4"
		CACHE STRING "Eclipse version" FORCE)
endif()

# version for user agent creation
set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 2)
set(PROJECT_VERSION_PATCH 8)
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

# output dir
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# use ccache if available
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK    ccache)
endif(CCACHE_FOUND)

# search for libs
find_package(CURL      REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Boost     REQUIRED filesystem system log program_options thread)

# set up wxWidgets to prefer gtk3
execute_process(COMMAND wx-config --selected-config --toolkit=gtk3
		RESULT_VARIABLE ret
		OUTPUT_QUIET)
if(ret EQUAL "0")
	message(STATUS "wxWidgets: Found gtk3 version, using it.")
	set(wxWidgets_CONFIG_OPTIONS_DEFAULT "--toolkit=gtk3")
else()
	message(STATUS "wxWidgets: No gtk3 version found, falling back to default (likely gtk2)")
endif()
unset(ret)
set(wxWidgets_CONFIG_OPTIONS "${wxWidgets_CONFIG_OPTIONS_DEFAULT}" ON STRING "wxWidgets toolkit options")
find_package(wxWidgets REQUIRED core base adv)
pkg_search_module(JSONCPP     REQUIRED jsoncpp)
pkg_search_module(GSTREAMER   REQUIRED gstreamer-1.0)
pkg_search_module(XDG_BASEDIR REQUIRED libxdg-basedir)
if (NOT APPLE)
    pkg_search_module(LIBBSD  REQUIRED libbsd)
endif(NOT APPLE)

# flags
set(CMAKE_CXX_STANDARD 14)
add_definitions("-DBOOST_LOG_DYN_LINK")
add_compile_options("-fdiagnostics-color=auto")
set(warnings "-Wall -Wextra -Werror -Wpedantic")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${warnings}")
set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} ${warnings}")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -s")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -s")

# includes etc.
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR}/src/ ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/ ${JSONCPP_INCLUDE_DIRS})

# notification & ncurses based on platform
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    pkg_search_module(APPINDICATOR appindicator3-0.1)
    if (NOT APPINDICATOR_FOUND)
        pkg_search_module(APPINDICATOR REQUIRED ayatana-appindicator3-0.1)
        if (APPINDICATOR_FOUND)
            set(AYATANA_APPINDICATOR true)
        endif()
    endif()
if (NOT APPINDICATOR_FOUND)
    pkg_search_module(NCURSES      REQUIRED ncurses)
endif()
    pkg_search_module(NOTIFY       REQUIRED libnotify)
    pkg_search_module(GLIBMM       REQUIRED glibmm-2.4)
    pkg_search_module(GIOMM        REQUIRED giomm-2.4)
else()
    set(NCURSES_FOUND true)
    set(NCURSES_LIBRARIES ncurses)
    set(NOTIFY_FOUND true)
    set(APPINDICATOR_FOUND false)
endif()

# build tests? Then we need googletest...
if (BUILD_TESTS)
    include(ExternalProject)

    ExternalProject_Add(googletest
        PREFIX "${CMAKE_CURRENT_BINARY_DIR}/googletest"
        URL https://github.com/google/googletest/archive/release-1.8.1.tar.gz
        URL_HASH SHA256=9bf1fe5182a604b4135edc1a425ae356c9ad15e9b23f9f12a02e80184c3a249c
        TIMEOUT 30
        DOWNLOAD_NO_PROGRESS true
        INSTALL_COMMAND "")

    ExternalProject_Get_Property(googletest SOURCE_DIR)
    include_directories(${SOURCE_DIR}/googlemock/include ${SOURCE_DIR}/googletest/include)
    ExternalProject_Get_Property(googletest BINARY_DIR)
    link_directories(${BINARY_DIR}/googlemock ${BINARY_DIR}/googlemock/gtest)
    set(GMOCK_BOTH_LIBRARIES gmock_main gmock gtest)
    set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM "${CMAKE_CURRENT_BINARY_DIR}/googletest")
    unset(SOURCE_DIR)
    unset(BINARY_DIR)

    enable_testing()
    add_subdirectory(tests)
    add_subdirectory(tests/runners/)
endif()

set(BUILD_SHARED_LIBS NO)

add_subdirectory(package)
add_subdirectory(src/radiotray-ng)
add_subdirectory(src/radiotray-ng/config)
add_subdirectory(src/radiotray-ng/playlist)
add_subdirectory(src/radiotray-ng/bookmarks)
add_subdirectory(src/radiotray-ng/event_bus)
add_subdirectory(src/radiotray-ng/player)
add_subdirectory(src/radiotray-ng/notification)
add_subdirectory(src/radiotray-ng/extras/media_keys)
add_subdirectory(src/radiotray-ng/gui/editor)

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(src/radiotray-ng/extras/rtng_dbus)
    target_compile_definitions(radiotray-ng PRIVATE RTNG_DBUS)
endif()

# which gui?
if (APPINDICATOR_FOUND)
    target_compile_definitions(radiotray-ng PRIVATE APPINDICATOR_GUI)
    add_subdirectory(src/radiotray-ng/gui/appindicator)
else()
    add_subdirectory(src/radiotray-ng/gui/ncurses)
endif()

# user agent
add_custom_command(
     OUTPUT  rtng_user_agent
    COMMENT "Generating rtng_user_agent.hpp"
    COMMAND ${CMAKE_COMMAND}
        -D PROJECT_SOURCE_DIR=${PROJECT_SOURCE_DIR}
        -D CMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        -D CMAKE_PROJECT_NAME=${CMAKE_PROJECT_NAME}
        -D PROJECT_VERSION=${PROJECT_VERSION}
        -D CMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
        -D CMAKE_SYSTEM_PROCESSOR=${CMAKE_SYSTEM_PROCESSOR}
        -P ${PROJECT_SOURCE_DIR}/cmake/user-agent.cmake
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
)

add_custom_target(user-agent ALL DEPENDS rtng_user_agent)

=== package/CMakeLists.txt ===
# gather system info...
find_program(LSB_RELEASE_EXECUTABLE NAMES lsb_release)

if (LSB_RELEASE_EXECUTABLE)
    execute_process(COMMAND lsb_release -c -s OUTPUT_VARIABLE CODENAME        OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND lsb_release -i -s OUTPUT_VARIABLE DISTRIBUTOR_ID  OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND lsb_release -r -s OUTPUT_VARIABLE RELEASE         OUTPUT_STRIP_TRAILING_WHITESPACE)

    # default to debian...
    string(TOLOWER ${DISTRIBUTOR_ID} DISTRIBUTOR_ID)
    if (NOT CPACK_GENERATOR)
        if (DISTRIBUTOR_ID STREQUAL "fedora")
            set(CPACK_GENERATOR "RPM")
        else()
            set(CPACK_GENERATOR "DEB")
        endif()
    endif()

    message( "Building version: ${PROJECT_VERSION} for ${DISTRIBUTOR_ID} ${RELEASE} -- ${CPACK_GENERATOR} packaging..." )

    set(CPACK_PACKAGE_VENDOR              "Edward G. Bruck")
    set(CPACK_PACKAGE_CONTACT             "ed.bruck1@gmail.com")
    set(CPACK_PACKAGE_NAME                "radiotray-ng")
    set(CPACK_PACKAGE_VERSION             ${PROJECT_VERSION})
    set(CPACK_PACKAGE_VERSION_MAJOR       ${PROJECT_VERSION_MAJOR})
    set(CPACK_PACKAGE_VERSION_MINOR       ${PROJECT_VERSION_MINOR})
    set(CPACK_PACKAGE_VERSION_PATCH       ${PROJECT_VERSION_PATCH})
    set(CPACK_PACKAGE_RELOCATABLE         FALSE)
    set(DESTINATION_DIR                   /usr/share/radiotray-ng/)

    if (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
        set(CPACK_SYSTEM_NAME "i386")
    else()
        if (DISTRIBUTOR_ID STREQUAL "fedora")
            set(CPACK_SYSTEM_NAME "x86_64")
        else()
            set(CPACK_SYSTEM_NAME "amd64")
        endif()
    endif()

    set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}_${PROJECT_VERSION}_${DISTRIBUTOR_ID}_${RELEASE}_${CPACK_SYSTEM_NAME})

    if (CPACK_GENERATOR MATCHES "DEB")
        set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "Simple Internet Radio Player\n Radiotray-NG runs in the system tray allowing you to\n select and play configured radio stations.")
        set(BOOST_DEB_VERSION                  "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")
        set(CPACK_DEBIAN_PACKAGE_SECTION       "sound")
        set(CPACK_DEBIAN_COMPRESSION_TYPE      "xz")
        set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE  ${CPACK_SYSTEM_NAME})
        set(CPACK_DEBIAN_PACKAGE_PRIORITY      "optional")
        set(CPACK_DEBIAN_PACKAGE_MAINTAINER    "Edward G. Bruck <ed.bruck1@gmail.com>")
        set(CPACK_DEBIAN_PACKAGE_DEPENDS       "libc6, libbsd0, libcurl4, libjsoncpp1, libxdg-basedir1, libnotify4, python3-lxml, libglibmm-2.4-1v5, libboost-filesystem${BOOST_DEB_VERSION}, libboost-system${BOOST_DEB_VERSION}, libboost-log${BOOST_DEB_VERSION}, libboost-thread${BOOST_DEB_VERSION}, libboost-program-options${BOOST_DEB_VERSION}, libgstreamer1.0-0, libappindicator3-1, gstreamer1.0-plugins-good, gstreamer1.0-plugins-bad, gstreamer1.0-plugins-ugly, libwxgtk3.0-gtk3-0v5")
        set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA ${PROJECT_SOURCE_DIR}/package/postinst;${PROJECT_SOURCE_DIR}/package/postrm;${PROJECT_SOURCE_DIR}/package/conffiles)

        if (${RELEASE} STREQUAL "21.04")
            string(REPLACE "libjsoncpp1" "libjsoncpp24" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
        endif()

        # no libcurl4 on Debian Stretch
        # https://bugs.launchpad.net/ubuntu/+source/curl/+bug/1754294
        if (${RELEASE} STREQUAL "16.04" OR ${CODENAME} STREQUAL "stretch")
            string(REPLACE "libcurl4" "libcurl3" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
        endif()

        # Debian no longer supports libjsoncpp1 and ubuntu appindicator package naming
        if (${CODENAME} STREQUAL "bullseye")
            string(REPLACE "libjsoncpp1" "libjsoncpp24" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
            string(REPLACE "libappindicator3-1" "libayatana-appindicator3-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
        endif()

        # official packages for older distros will continue to use gtk2 for the editor
        if (${RELEASE} STREQUAL "16.04" OR ${RELEASE} STREQUAL "18.04" OR ${RELEASE} STREQUAL "19.04" OR ${CODENAME} STREQUAL "stretch")
            message(STATUS "Official packaging assumes gtk2 dependency for 'rtng-bookmark-editor'")
            string(REPLACE "libwxgtk3.0-gtk3-0v5" "libwxgtk3.0-0v5" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
        endif()

        execute_process(COMMAND gzip -n -9 -c "${PROJECT_SOURCE_DIR}/package/changelog-deb" WORKING_DIRECTORY ${PROJECT_BINARY_DIR} OUTPUT_FILE "${PROJECT_BINARY_DIR}/changelog.Debian.gz")

        # for 16.04
        execute_process(COMMAND chmod 755 ${PROJECT_SOURCE_DIR}/package/postinst)
        execute_process(COMMAND chmod 755 ${PROJECT_SOURCE_DIR}/package/postrm)
        execute_process(COMMAND chmod 644 ${PROJECT_SOURCE_DIR}/package/conffiles)

        install(DIRECTORY ${PROJECT_SOURCE_DIR}/data/themes/ubuntu-mono-dark/apps/24/  DESTINATION /usr/share/icons/ubuntu-mono-dark/apps/24  FILES_MATCHING PATTERN *.svg)
        install(DIRECTORY ${PROJECT_SOURCE_DIR}/data/themes/ubuntu-mono-light/apps/24/ DESTINATION /usr/share/icons/ubuntu-mono-light/apps/24 FILES_MATCHING PATTERN *.svg)
        install(FILES     ${PROJECT_SOURCE_DIR}/package/copyright                      DESTINATION /usr/share/doc/${CPACK_PACKAGE_NAME})
        install(FILES     ${PROJECT_BINARY_DIR}/changelog.Debian.gz                    DESTINATION /usr/share/doc/${CPACK_PACKAGE_NAME})
    endif()

    if (CPACK_GENERATOR MATCHES "RPM")
        set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "Simple Internet Radio Player. Radiotray-NG runs in the system tray allowing you to select and play configured radio stations.")
        set(CPACK_RPM_PACKAGE_URL      "https://www.github.com/ebruck/radiotray-ng")
        set(CPACK_RPM_PACKAGE_REQUIRES "glibc, libcurl, jsoncpp, boost, libxdg-basedir, libbsd, libappindicator-gtk3, libnotify, glibmm24, python3-lxml, gstreamer-plugins-base, gstreamer-plugins-good, gstreamer-plugins-bad-free, wxGTK3")
        set(CPACK_RPM_PACKAGE_GROUP    "Applications/Multimedia")
        set(CPACK_RPM_PACKAGE_LICENSE  "GPLv3")
        set(CPACK_RPM_COMPRESSION_TYPE "xz")
        set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE   ${PROJECT_SOURCE_DIR}/package/postinst)
        set(CPACK_RPM_POST_UNINSTALL_SCRIPT_FILE ${PROJECT_SOURCE_DIR}/package/postrm)

        install(FILES ${PROJECT_SOURCE_DIR}/README.md DESTINATION /usr/share/doc/${CPACK_PACKAGE_NAME})
        install(FILES ${PROJECT_SOURCE_DIR}/AUTHORS   DESTINATION /usr/share/doc/${CPACK_PACKAGE_NAME})
        install(FILES ${PROJECT_SOURCE_DIR}/COPYING   DESTINATION /usr/share/licences/${CPACK_PACKAGE_NAME})

        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/applications)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/metainfo)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/licences)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/hicolor)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/hicolor/24x24)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/hicolor/24x24/apps)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/hicolor/256x256)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/hicolor/256x256/apps)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/breeze)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/breeze/apps)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/breeze/apps/22)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/breeze/apps/48)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/Yaru)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/Yaru/256x256)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/share/icons/Yaru/256x256/apps)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /etc/xdg)
        list(APPEND CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /etc/xdg/autostart)

        set(CPACK_RPM_CHANGELOG_FILE ${PROJECT_SOURCE_DIR}/package/changelog-rpm)
    endif()

    install(FILES ${PROJECT_SOURCE_DIR}/data/themes/hicolor/256x256/apps/radiotray-ng-on.png
                  ${PROJECT_SOURCE_DIR}/data/themes/hicolor/256x256/apps/radiotray-ng-off.png
                  ${PROJECT_SOURCE_DIR}/data/themes/hicolor/256x256/apps/radiotray-ng-notification.png
                  DESTINATION /usr/share/icons/hicolor/256x256/apps)

    install(FILES ${PROJECT_SOURCE_DIR}/data/themes/hicolor/24x24/apps/radiotray-ng-on.png
                  ${PROJECT_SOURCE_DIR}/data/themes/hicolor/24x24/apps/radiotray-ng-off.png
                  DESTINATION /usr/share/icons/hicolor/24x24/apps)

    install(FILES ${PROJECT_SOURCE_DIR}/data/themes/Yaru/256x256/apps/radiotray-ng-notification.png
                  DESTINATION /usr/share/icons/Yaru/256x256/apps)

    install(FILES ${PROJECT_SOURCE_DIR}/data/themes/breeze/apps/22/radiotray-ng-on.svg
                  ${PROJECT_SOURCE_DIR}/data/themes/breeze/apps/22/radiotray-ng-off.svg
                  DESTINATION /usr/share/icons/breeze/apps/22)

    install(FILES ${PROJECT_SOURCE_DIR}/data/themes/breeze/apps/48/radiotray-ng-notification.svg
                  DESTINATION /usr/share/icons/breeze/apps/48)

    install(FILES     ${PROJECT_SOURCE_DIR}/data/about/radiotray-ng.png             DESTINATION ${DESTINATION_DIR})
    install(FILES     ${PROJECT_SOURCE_DIR}/data/bookmarks.json                     DESTINATION ${DESTINATION_DIR})
    install(FILES     ${PROJECT_SOURCE_DIR}/data/radiotray-ng.desktop               DESTINATION /usr/share/applications/)
    install(FILES     ${PROJECT_SOURCE_DIR}/data/rtng-bookmark-editor.desktop       DESTINATION /usr/share/applications/)
    install(FILES     ${PROJECT_SOURCE_DIR}/data/radiotray-ng.appdata.xml           DESTINATION /usr/share/metainfo/)
    install(FILES     ${PROJECT_SOURCE_DIR}/data/radiotray-ng.desktop               DESTINATION /etc/xdg/autostart/)
    install(PROGRAMS  ${PROJECT_SOURCE_DIR}/src/radiotray-ng/extras/scripts/rt2rtng DESTINATION /usr/bin/)
    install(PROGRAMS  ${PROJECT_BINARY_DIR}/radiotray-ng                            DESTINATION /usr/bin/)
    install(PROGRAMS  ${PROJECT_BINARY_DIR}/rtng-bookmark-editor                    DESTINATION /usr/bin/)

    include(CPack)
else()
    message(AUTHOR_WARNING "lsb_release not found! -- packaging disabled")
endif()

=== tests/CMakeLists.txt ===
include(GoogleTest)

function(add_gmock_test target)
    add_executable(${target} ${ARGN})
    add_dependencies(${target} googletest)
    target_link_libraries(${target} config playlist bookmarks event_bus ${GMOCK_BOTH_LIBRARIES} ${XDG_BASEDIR_LIBRARIES} ${Boost_LIBRARIES} ${CURL_LIBRARIES} ${JSONCPP_LIBRARIES} pthread)
    target_include_directories(${target} PRIVATE ${JSONCPP_INCLUDE_DIRS})
    gtest_discover_tests(${target})
endfunction()

# utests
add_gmock_test(pls_decoder_utests pls_decoder_test.cpp)
add_gmock_test(m3u_decoder_utests m3u_decoder_test.cpp)
add_gmock_test(asx_decoder_utests asx_decoder_test.cpp)
add_gmock_test(asf_decoder_utests asf_decoder_test.cpp)
add_gmock_test(ram_decoder_utests ram_decoder_test.cpp)
add_gmock_test(xspf_decoder_utests xspf_decoder_test.cpp)
add_gmock_test(event_bus_utests event_bus_test.cpp)
add_gmock_test(bookmarks_utests bookmarks_test.cpp)
add_gmock_test(config_utests config_test.cpp)
add_gmock_test(ds_decoder_utests ds_decoder_test.cpp)

=== src/radiotray-ng/CMakeLists.txt ===
add_executable(radiotray-ng main.cpp radiotray_ng.cpp radiotray_ng.hpp)

if (APPINDICATOR_FOUND)
    if (AYATANA_APPINDICATOR)
        target_compile_definitions(radiotray-ng PRIVATE AYATANA_APPINDICATOR)
    endif()

    target_link_libraries(
        radiotray-ng
        appindicator_gui
        ${APPINDICATOR_LIBRARIES})
else()
    target_link_libraries(
        radiotray-ng
        ncurses_gui
        ${NCURSES_LIBRARIES})
endif()    

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    target_link_libraries(radiotray-ng rtng_dbus)
endif()

target_link_libraries(
  radiotray-ng  
  bookmarks  
  config
  event_bus
  player
  playlist
  notification
  media_keys
  ${NOTIFY_LIBRARIES}
  ${CURL_LIBRARIES}
  ${Boost_LIBRARIES}
  ${XDG_BASEDIR_LIBRARIES}
  ${JSONCPP_LIBRARIES}
  ${GSTREAMER_LIBRARIES}
  ${GIO_LIBRARIES}
  ${LIBBSD_LIBRARIES}
  pthread
)

add_dependencies(radiotray-ng user-agent)
target_include_directories(radiotray-ng SYSTEM PRIVATE ${CMAKE_RUNTIME_OUTPUT_DIRECTORY} ${GSTREAMER_INCLUDE_DIRS} ${APPINDICATOR_INCLUDE_DIRS} ${GIOMM_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS})

=== src/radiotray-ng/event_bus/CMakeLists.txt ===
add_library(event_bus STATIC event_bus.cpp event_bus.hpp)

=== src/radiotray-ng/player/CMakeLists.txt ===
add_library(player STATIC player.cpp player.hpp)
target_link_libraries(player ${APPINDICATOR_LIBRARIES})
add_dependencies(player user-agent)
target_include_directories(player PRIVATE ${GSTREAMER_INCLUDE_DIRS} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

=== src/radiotray-ng/playlist/CMakeLists.txt ===
add_library(playlist STATIC
    asf_decoder.cpp
    asf_decoder.hpp
    asx_decoder.cpp
    asx_decoder.hpp
    m3u_decoder.cpp
    m3u_decoder.hpp
    ds_decoder.cpp
    ds_decoder.hpp
    pls_decoder.cpp
    pls_decoder.hpp
    ram_decoder.cpp
    ram_decoder.hpp
    xspf_decoder.cpp
    xspf_decoder.hpp
    playlist_downloader.cpp
    playlist_downloader.hpp)

add_dependencies(playlist user-agent)
target_include_directories(playlist PRIVATE ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

=== src/radiotray-ng/extras/rtng_dbus/CMakeLists.txt ===
add_library(rtng_dbus STATIC rtng_dbus.cpp rtng_dbus.hpp)
target_link_libraries(rtng_dbus ${GLIBMM_LIBRARIES} ${GIOMM_LIBRARIES})
target_include_directories(rtng_dbus SYSTEM PRIVATE ${GIOMM_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS})

=== debian/changelog ===
radiotray-ng (0.2.8-0mx21) mx; urgency=medium

  * Rebuild for MX-21

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 06 Dec 2022 14:09:35 -0500

radiotray-ng (0.2.8) unstable; urgency=low

      * MATE media key support
      * Minor cleanup & bug fixes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 21 Aug 2021 12:48:02 -0700

radiotray-ng (0.2.7) unstable; urgency=low

      * Removed python2 dependency
      * Bookmark saving no longer includes default entries
      * Volume level changes using pavucontrol etc. are now detected
      * Minor cleanup & bug fixes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sun, 20 Oct 2019 13:53:10 -0700

radiotray-ng (0.2.6) unstable; urgency=low

      * Added disable-logging config option
      * Added Yaru & Breeze icons
      * Log & pid files now written to standard xdg locations
      * RPM packaging
      * get_player_state dbus now includes url information
      * Added dbus mute method
      * Minor build changes & bug fixes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sun, 07 Jul 2019 09:30:14 -0700

radiotray-ng (0.2.5) unstable; urgency=low

      * Updated & added new stations
      * Added dbus play_url method
      * Added initial m3u8 support
      * Various dbus & editor bug fixes
      * Added rtng-dbus & rtng2xml scripts

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Fri, 15 Mar 2019 22:57:10 -0700

radiotray-ng (0.2.4) unstable; urgency=low

      * Added dbus set_volume method
      * Added root-group-bottom-pos config option
      * Notification icon visibility on light backgrounds improved
      * Minor build changes & bug fixes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Wed, 17 Oct 2018 21:19:49 -0700

radiotray-ng (0.2.3) unstable; urgency=low

      * Fixed playlist line ending type detection
      * Added wrap-track-info & wrap-track-info-len config options
      * Better handling of text/uri-list & text/html playlists
      * Minor build changes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Fri, 13 Jul 2018 21:30:00 -0700

radiotray-ng (0.2.2) unstable; urgency=low

      * Added copying title & artist to clipboard config option
      * Added per station notification option & editor support
      * Added dbus reload_bookmarks & quit methods
      * Minor build changes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Tue, 24 Apr 2018 21:25:51 -0700

radiotray-ng (0.2.1) unstable; urgency=low

      * Fixed editor group & station reordering
      * Added BUILD_TESTS cmake option
      * Added dbus get_config method

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 17 Feb 2018 08:52:41 -0800

radiotray-ng (0.2.0) unstable; urgency=low

      * Added contributed Bookmark Editor (Thanks Mike!)
      * Added iHeartRadio tag parsing
      * Added buffer-duration config option
      * Fixed jsoncpp build warnings breaking Arch builds
      * Minor bug fixes

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 30 Dec 2017 16:27:34 -0800

radiotray-ng (0.1.8) unstable; urgency=low

      * Added icon middle click support for starting/stopping playback
      * Added command line help etc.
      * Added invert-menu configuration option for bottom dock users
      * Added Bluegrass station to default bookmark file
      * Fixed wrong api used for menu separators
      * Fixed output not using autoaudiosink
      * Reduced notifications if player buffers

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 07 Oct 2017 11:00:07 -0700

radiotray-ng (0.1.7) unstable; urgency=low

      * Added dbus interface
      * Added --play option for resuming playback on startup
      * Added optional notification of external bookmark file changes
      * Updated to libappindicator3

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 02 Sep 2017 11:01:19 -0700

radiotray-ng (0.1.6) unstable; urgency=low

      * new icon config overrides
      * sleep timer dialog added
      * support for gnome-settings-daemon media key api changes
      * added Fedora build instructions

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Wed, 28 Jun 2017 20:16:07 -0700

radiotray-ng (0.1.5) unstable; urgency=low

      * Fixed startup crash seen on some systems using gcc 6.x
      * Added compact-menu option to disable the use of menu separators
      * Removed ncurses requirement if appindicator library is found
      * Notification uses station name if artist tag is missing
      * Smarter boost dependency detection
      * Added rt2rtng script for converting RadioTray bookmarks
      * Fixed user-agent and release build issues
      * Logging & aboutbox now include git commit used to generate binary
      * Added optional mapping of media keys for previous/next station etc

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 22 Apr 2017 16:04:25 -0700

radiotray-ng (0.1.4) unstable; urgency=low

      * Disabling notifications prevented stopping of player
      * Fixed lintian package errors

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Thu, 23 Feb 2017 18:49:38 -0800

radiotray-ng (0.1.3) unstable; urgency=low

      * Support building on 32bit architectures
      * Added 24x24 icons and pid file to prevent multiple instances from
        running

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 18 Feb 2017 14:44:27 -0800

radiotray-ng (0.1.2) unstable; urgency=low

      *  Fixed gdk threading not being initialized before calling gtk_init
      *  Don't overwrite bad bookmarks file on startup

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Wed, 15 Feb 2017 19:47:03 -0800

radiotray-ng (0.1.1) unstable; urgency=low

	  * Fixed word_wrap infinite loop

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sun, 12 Feb 2017 12:58:39 -0800

radiotray-ng (0.1.0) unstable; urgency=low

	  * Initial release.

 -- Edward G. Bruck <ed.bruck1@gmail.com>  Sat, 11 Feb 2017 12:10:00 -0800

=== debian/control ===
Source: radiotray-ng
Section: sound
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
Build-Depends: cmake (>= 3.1), 
               debhelper (>= 12~),
               lsb-release,
               libappindicator3-dev,
               libcurl4-openssl-dev,
               libjsoncpp-dev,
               libxdg-basedir-dev,
               libnotify-dev,
               libboost-filesystem-dev,
               libgstreamer1.0-dev,
               libboost-log-dev,
               libboost-program-options-dev,
               libgtk-3-dev,
               libnotify-dev,
               lsb-release,
               libbsd-dev,
               libncurses5-dev,
               libglibmm-2.4-dev,
               libwxgtk3.0-gtk3-dev,
               libwxgtk3.0-gtk3-0v5
Standards-Version: 4.5.8
Homepage: https://github.com/ebruck/radiotray-ng

Package: radiotray-ng
Architecture: any
Depends: gstreamer1.0-plugins-good, gstreamer1.0-plugins-bad, gstreamer1.0-plugins-ugly,
         ${misc:Depends}, ${shlibs:Depends}
Description: An Internet radio player for Linux
 Radiotray-NG works directly from the system tray instead of having
 a separate main window.  It's a minimal yet fully functional
 streaming internet radio app.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@
        
override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTS=ON -DCMAKE_BUILD_TYPE=Debug

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## radiotray-ng 0.2.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
 cmake_minimum_required(VERSION 3.10)
+
+if(POLICY CMP0167)
+  cmake_policy(SET CMP0167 OLD)
+endif()
 
 project(radiotray-ng CXX)
 
@@ -13,7 +17,7 @@
 # version for user agent creation
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 2)
-set(PROJECT_VERSION_PATCH 8)
+set(PROJECT_VERSION_PATCH 10.1)
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # output dir
@@ -29,7 +33,7 @@
 # search for libs
 find_package(CURL      REQUIRED)
 find_package(PkgConfig REQUIRED)
-find_package(Boost     REQUIRED filesystem system log program_options thread)
+find_package(Boost     REQUIRED filesystem log program_options thread)
 
 # set up wxWidgets to prefer gtk3
 execute_process(COMMAND wx-config --selected-config --toolkit=gtk3
@@ -55,7 +59,7 @@
 set(CMAKE_CXX_STANDARD 14)
 add_definitions("-DBOOST_LOG_DYN_LINK")
 add_compile_options("-fdiagnostics-color=auto")
-set(warnings "-Wall -Wextra -Werror -Wpedantic")
+set(warnings "-Wall -Wextra -Werror -Wpedantic -Wno-deprecated-declarations")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${warnings}")
 set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} ${warnings}")
 set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -s")
@@ -70,7 +74,7 @@
     if (NOT APPINDICATOR_FOUND)
         pkg_search_module(APPINDICATOR REQUIRED ayatana-appindicator3-0.1)
         if (APPINDICATOR_FOUND)
-            set(AYATANA_APPINDICATOR true)
+            set(AYATANA_APPINDICATOR true CACHE BOOL "ayatana-appindicator")
         endif()
     endif()
 if (NOT APPINDICATOR_FOUND)
@@ -92,8 +96,9 @@
 
     ExternalProject_Add(googletest
         PREFIX "${CMAKE_CURRENT_BINARY_DIR}/googletest"
-        URL https://github.com/google/googletest/archive/release-1.8.1.tar.gz
-        URL_HASH SHA256=9bf1fe5182a604b4135edc1a425ae356c9ad15e9b23f9f12a02e80184c3a249c
+        URL https://github.com/google/googletest/releases/download/v1.15.2/googletest-1.15.2.tar.gz
+        URL_HASH SHA256=7b42b4d6ed48810c5362c265a17faebe90dc2373c885e5216439d37927f02926
+        DOWNLOAD_EXTRACT_TIMESTAMP true
         TIMEOUT 30
         DOWNLOAD_NO_PROGRESS true
         INSTALL_COMMAND "")
@@ -101,7 +106,7 @@
     ExternalProject_Get_Property(googletest SOURCE_DIR)
     include_directories(${SOURCE_DIR}/googlemock/include ${SOURCE_DIR}/googletest/include)
     ExternalProject_Get_Property(googletest BINARY_DIR)
-    link_directories(${BINARY_DIR}/googlemock ${BINARY_DIR}/googlemock/gtest)
+    link_directories(${BINARY_DIR}/lib)
     set(GMOCK_BOTH_LIBRARIES gmock_main gmock gtest)
     set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM "${CMAKE_CURRENT_BINARY_DIR}/googletest")
     unset(SOURCE_DIR)

=== package/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,11 @@
     execute_process(COMMAND lsb_release -c -s OUTPUT_VARIABLE CODENAME        OUTPUT_STRIP_TRAILING_WHITESPACE)
     execute_process(COMMAND lsb_release -i -s OUTPUT_VARIABLE DISTRIBUTOR_ID  OUTPUT_STRIP_TRAILING_WHITESPACE)
     execute_process(COMMAND lsb_release -r -s OUTPUT_VARIABLE RELEASE         OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+    # handle distros that identify release as n/a...
+    if (RELEASE STREQUAL "n/a")
+        set(RELEASE "na")
+    endif()
 
     # default to debian...
     string(TOLOWER ${DISTRIBUTOR_ID} DISTRIBUTOR_ID)
@@ -41,24 +46,40 @@
     set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}_${PROJECT_VERSION}_${DISTRIBUTOR_ID}_${RELEASE}_${CPACK_SYSTEM_NAME})
 
     if (CPACK_GENERATOR MATCHES "DEB")
-        set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "Simple Internet Radio Player\n Radiotray-NG runs in the system tray allowing you to\n select and play configured radio stations.")
+        set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  "Simple Internet Radio Player\nRadiotray-NG runs in the system tray allowing you to\n select and play configured radio stations.")
         set(BOOST_DEB_VERSION                  "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_SUBMINOR_VERSION}")
         set(CPACK_DEBIAN_PACKAGE_SECTION       "sound")
         set(CPACK_DEBIAN_COMPRESSION_TYPE      "xz")
         set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE  ${CPACK_SYSTEM_NAME})
         set(CPACK_DEBIAN_PACKAGE_PRIORITY      "optional")
         set(CPACK_DEBIAN_PACKAGE_MAINTAINER    "Edward G. Bruck <ed.bruck1@gmail.com>")
-        set(CPACK_DEBIAN_PACKAGE_DEPENDS       "libc6, libbsd0, libcurl4, libjsoncpp1, libxdg-basedir1, libnotify4, python3-lxml, libglibmm-2.4-1v5, libboost-filesystem${BOOST_DEB_VERSION}, libboost-system${BOOST_DEB_VERSION}, libboost-log${BOOST_DEB_VERSION}, libboost-thread${BOOST_DEB_VERSION}, libboost-program-options${BOOST_DEB_VERSION}, libgstreamer1.0-0, libappindicator3-1, gstreamer1.0-plugins-good, gstreamer1.0-plugins-bad, gstreamer1.0-plugins-ugly, libwxgtk3.0-gtk3-0v5")
+        set(CPACK_DEBIAN_PACKAGE_DEPENDS       "libc6, libbsd0, libcurl4, libjsoncpp1, libxdg-basedir1, libnotify4, python3, python3-lxml, libglibmm-2.4-1v5, libboost-filesystem${BOOST_DEB_VERSION}, libboost-system${BOOST_DEB_VERSION}, libboost-log${BOOST_DEB_VERSION}, libboost-thread${BOOST_DEB_VERSION}, libboost-program-options${BOOST_DEB_VERSION}, libgstreamer1.0-0, libappindicator3-1, gstreamer1.0-plugins-good, gstreamer1.0-plugins-bad, gstreamer1.0-plugins-ugly, libwxgtk3.0-gtk3-0v5")
         set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA ${PROJECT_SOURCE_DIR}/package/postinst;${PROJECT_SOURCE_DIR}/package/postrm;${PROJECT_SOURCE_DIR}/package/conffiles)
 
-        if (${RELEASE} STREQUAL "21.04")
-            string(REPLACE "libjsoncpp1" "libjsoncpp24" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+        # ubuntu and mint
+        if (${RELEASE} STREQUAL "22.04" OR ${RELEASE} STREQUAL "21.3" OR ${RELEASE} STREQUAL "22" OR ${RELEASE} STREQUAL "24.04" OR ${RELEASE} STREQUAL "24.10")
+            string(REPLACE "libjsoncpp1" "libjsoncpp25" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+            string(REPLACE "libappindicator3-1" "libayatana-appindicator3-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+        # support for Ubuntu 25.04 and 25.10
+        else()
+             if (${RELEASE} STREQUAL "25.04" OR ${RELEASE} STREQUAL "25.10")
+                 string(REPLACE "libjsoncpp1" "libjsoncpp26" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+                 string(REPLACE "libappindicator3-1" "libayatana-appindicator3-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+             endif()
         endif()
 
-        # no libcurl4 on Debian Stretch
-        # https://bugs.launchpad.net/ubuntu/+source/curl/+bug/1754294
-        if (${RELEASE} STREQUAL "16.04" OR ${CODENAME} STREQUAL "stretch")
-            string(REPLACE "libcurl4" "libcurl3" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+        # Debian 13
+        if (${CODENAME} STREQUAL "trixie")
+            string(REPLACE "libjsoncpp1" "libjsoncpp26" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+            string(REPLACE "libappindicator3-1" "libayatana-appindicator3-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+            string(REPLACE "libwxgtk3.0-gtk3-0v5" "libwxgtk3.2-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+        endif()
+
+        # Debian 12
+        if (${CODENAME} STREQUAL "bookworm")
+            string(REPLACE "libjsoncpp1" "libjsoncpp25" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+            string(REPLACE "libappindicator3-1" "libayatana-appindicator3-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+            string(REPLACE "libwxgtk3.0-gtk3-0v5" "libwxgtk3.2-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
         endif()
 
         # Debian no longer supports libjsoncpp1 and ubuntu appindicator package naming
@@ -67,15 +88,20 @@
             string(REPLACE "libappindicator3-1" "libayatana-appindicator3-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
         endif()
 
-        # official packages for older distros will continue to use gtk2 for the editor
-        if (${RELEASE} STREQUAL "16.04" OR ${RELEASE} STREQUAL "18.04" OR ${RELEASE} STREQUAL "19.04" OR ${CODENAME} STREQUAL "stretch")
-            message(STATUS "Official packaging assumes gtk2 dependency for 'rtng-bookmark-editor'")
-            string(REPLACE "libwxgtk3.0-gtk3-0v5" "libwxgtk3.0-0v5" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+        # ubuntu noble and mint 22 has newer libwsxgtk
+        if (${RELEASE} STREQUAL "22" OR ${RELEASE} STREQUAL "24.04" OR ${RELEASE} STREQUAL "24.10")
+            message(STATUS "Official packaging assumes gtk3 dependency for 'rtng-bookmark-editor'")
+            string(REPLACE "libwxgtk3.0-gtk3-0v5" "libwxgtk3.2-1" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+        # support for Ubuntu 25.04 and 25.10
+        else()
+             if (${RELEASE} STREQUAL "25.04" OR ${RELEASE} STREQUAL "25.10")
+                 message(STATUS "Official packaging assumes gtk3 dependency for 'rtng-bookmark-editor'")
+                 string(REPLACE "libwxgtk3.0-gtk3-0v5" "libwxgtk3.2-1t64" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+             endif()
         endif()
 
         execute_process(COMMAND gzip -n -9 -c "${PROJECT_SOURCE_DIR}/package/changelog-deb" WORKING_DIRECTORY ${PROJECT_BINARY_DIR} OUTPUT_FILE "${PROJECT_BINARY_DIR}/changelog.Debian.gz")
 
-        # for 16.04
         execute_process(COMMAND chmod 755 ${PROJECT_SOURCE_DIR}/package/postinst)
         execute_process(COMMAND chmod 755 ${PROJECT_SOURCE_DIR}/package/postrm)
         execute_process(COMMAND chmod 644 ${PROJECT_SOURCE_DIR}/package/conffiles)
@@ -145,13 +171,3 @@
     install(FILES     ${PROJECT_SOURCE_DIR}/data/bookmarks.json                     DESTINATION ${DESTINATION_DIR})
     install(FILES     ${PROJECT_SOURCE_DIR}/data/radiotray-ng.desktop               DESTINATION /usr/share/applications/)
     install(FILES     ${PROJECT_SOURCE_DIR}/data/rtng-bookmark-editor.desktop       DESTINATION /usr/share/applications/)
-    install(FILES     ${PROJECT_SOURCE_DIR}/data/radiotray-ng.appdata.xml           DESTINATION /usr/share/metainfo/)
-    install(FILES     ${PROJECT_SOURCE_DIR}/data/radiotray-ng.desktop               DESTINATION /etc/xdg/autostart/)
-    install(PROGRAMS  ${PROJECT_SOURCE_DIR}/src/radiotray-ng/extras/scripts/rt2rtng DESTINATION /usr/bin/)
-    install(PROGRAMS  ${PROJECT_BINARY_DIR}/radiotray-ng                            DESTINATION /usr/bin/)
-    install(PROGRAMS  ${PROJECT_BINARY_DIR}/rtng-bookmark-editor                    DESTINATION /usr/bin/)
-
-    include(CPack)
-else()
-    message(AUTHOR_WARNING "lsb_release not found! -- packaging disabled")
-endif()

=== tests/runners/CMakeLists.txt ===
# test "runner" apps
if (BUILD_TESTS)
    add_executable(playlist_runner playlist_runner.cpp)
    target_link_libraries(playlist_runner playlist config ${JSONCPP_LIBRARIES} ${XDG_BASEDIR_LIBRARIES} ${Boost_LIBRARIES} ${CURL_LIBRARIES} pthread)
    target_include_directories(playlist_runner PRIVATE ${JSONCPP_INCLUDE_DIRS})

    add_executable(bookmarks_runner bookmarks_runner.cpp)
    target_link_libraries(bookmarks_runner bookmarks ${JSONCPP_LIBRARIES} ${Boost_LIBRARIES} pthread)
    target_include_directories(bookmarks_runner PRIVATE ${JSONCPP_INCLUDE_DIRS})

    add_executable(notification_runner notification_runner.cpp)
    target_link_libraries(notification_runner notification ${NOTIFY_LIBRARIES} ${Boost_LIBRARIES} pthread)
    target_include_directories(notification_runner PRIVATE ${NOTIFY_INCLUDE_DIRS})

    add_executable(player_runner player_runner.cpp)
    target_link_libraries(player_runner player event_bus notification config ${JSONCPP_LIBRARIES} ${NOTIFY_LIBRARIES} ${Boost_LIBRARIES} ${GSTREAMER_LIBRARIES} pthread)
    target_include_directories(player_runner PRIVATE ${GSTREAMER_INCLUDE_DIRS} ${JSONCPP_INCLUDE_DIRS})
endif()

=== src/radiotray-ng/bookmarks/CMakeLists.txt ===
add_library(bookmarks STATIC bookmarks.cpp bookmarks.hpp)

=== src/radiotray-ng/config/CMakeLists.txt ===
add_library(config STATIC config.cpp config.hpp)

=== src/radiotray-ng/notification/CMakeLists.txt ===
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(SRC_FILES linux/notification.cpp)
else()
    set(SRC_FILES darwin/notification.cpp)
endif()

add_library(notification STATIC ${SRC_FILES})

target_include_directories(notification PRIVATE ${NOTIFY_INCLUDE_DIRS})

=== src/radiotray-ng/extras/media_keys/CMakeLists.txt ===
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(SRC_FILES linux/media_keys.cpp)
else()
    set(SRC_FILES darwin/media_keys.cpp)
endif()

add_library(media_keys STATIC ${SRC_FILES})

# todo: if appindicator add the includes
target_link_libraries(media_keys ${APPINDICATOR_GUI} ${GIOMM_LIBRARIES})
target_include_directories(media_keys SYSTEM PRIVATE ${GIOMM_INCLUDE_DIRS} ${APPINDICATOR_INCLUDE_DIRS} )

=== src/radiotray-ng/gui/appindicator/CMakeLists.txt ===
add_library(appindicator_gui STATIC appindicator_gui.cpp appindicator_gui.hpp)
add_dependencies(appindicator_gui user-agent)

if (AYATANA_APPINDICATOR)
    target_compile_definitions(appindicator_gui PRIVATE APPINDICATOR_GUI AYATANA_APPINDICATOR)
else()
    target_compile_definitions(appindicator_gui PRIVATE APPINDICATOR_GUI)
endif()
target_include_directories(appindicator_gui SYSTEM PRIVATE ${APPINDICATOR_INCLUDE_DIRS})

=== src/radiotray-ng/gui/editor/CMakeLists.txt ===
set(SRC_FILES
	editor_app.cpp
	editor_app.hpp
	editor_bookmarks.cpp
	editor_bookmarks.hpp
	editor_dialog_base.cpp
	editor_dialog_base.hpp
	editor_frame.cpp
	editor_frame.hpp
	group_drop_target.cpp
	group_drop_target.hpp
	group_editor_dialog.cpp
	group_editor_dialog.hpp
	group_list.cpp
	group_list.hpp
	image_list.cpp
	image_list.hpp
	station_drop_target.cpp
	station_drop_target.hpp
	station_editor_dialog.cpp
	station_editor_dialog.hpp
	station_list.cpp
	station_list.hpp
	status_dialog.cpp
	status_dialog.hpp
	wx_pch.hpp)

include(${wxWidgets_USE_FILE})
add_executable(rtng-bookmark-editor ${SRC_FILES})
add_dependencies(rtng-bookmark-editor bookmarks config user-agent)

include_directories(rtng-bookmark-editor ${wxWidgets_INCLUDE_DIRS})
target_link_libraries(rtng-bookmark-editor
	bookmarks
	config
	${Boost_LIBRARIES}
	${XDG_BASEDIR_LIBRARIES}
	${JSONCPP_LIBRARIES}
	${wxWidgets_LIBRARIES}
	${LIBBSD_LIBRARIES}
)

target_compile_definitions(rtng-bookmark-editor PRIVATE BOOKMARKS_EDITOR)

=== src/radiotray-ng/gui/ncurses/CMakeLists.txt ===
add_library(ncurses_gui STATIC ncurses_gui.cpp ncurses_gui.hpp)

=== debian/changelog ===
radiotray-ng (0.2.10.1-0mx25) mx; urgency=medium

  * New upstream release

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 17 Nov 2025 17:38:30 +0000

radiotray-ng (0.2.8-0mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Fri, 09 Jun 2023 10:10:58 -0400

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@
        
override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTS=ON -DCMAKE_BUILD_TYPE=Release

override_dh_strip:
	dh_strip --no-automatic-dbgsym
